<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>webcontrols - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="Measure.html">Measure</a><ul class='methods'><li data-type='method' style='display: none;'><a href="Measure.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="Measure.html#add">add</a></li><li data-type='method' style='display: none;'><a href="Measure.html#asString">asString</a></li></ul></li><li><a href="webcontrols.html">webcontrols</a><ul class='members'><li data-type='member' style='display: none;'><a href="webcontrols.html#.verbose">verbose</a></li></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="webcontrols.html#.addButtonOnOff">addButtonOnOff</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.addButtonRange">addButtonRange</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.addConsole">addConsole</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.consoleLog">consoleLog</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.loadJSON">loadJSON</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.consoleClear">consoleClear</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.curl">curl</a></li></ul></li></ul><h3>Global</h3><ul><li><a href="global.html#answer">answer</a></li><li><a href="global.html#gpio_digital_timing_start">gpio_digital_timing_start</a></li><li><a href="global.html#gpio_digital_timing_stop">gpio_digital_timing_stop</a></li><li><a href="global.html#gpio_digital_timing_get">gpio_digital_timing_get</a></li><li><a href="global.html#setInterval">setInterval</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">webcontrols</h1>
    

    




<section>

<header>
    
        <h2>
        
            webcontrols
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="webcontrols"><span class="type-signature"></span>factory webcontrols<span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements Javascript mechanisms to dialog with a connected object via a web page.</p>
<ul>
<li>In order to use these functionnalities, use a construct of the form:</li>
</ul>
<pre class="prettyprint source"><code>&lt;html>
 &lt;head>
  &lt;!-- page title and others head elements -->
   &lt;link rel='stylesheet' href='https://line.gitlabpages.inria.fr/aide-group/esp32gpiocontrol/webcontrols.css'/>
   &lt;script type='text/javascript' src='https://line.gitlabpages.inria.fr/aide-group/esp32gpiocontrol/webcontrols.js'>&lt;/script>
 &lt;/head>
 &lt;body style='width:800px'>
  &lt;!-- page content -->
 &lt;/body>
&lt;/html>
</code></pre>
<ul>
<li>To add a control button in this framewrok, simply introduce a construct of the form, adjusting the style at will:</li>
</ul>
<pre class="prettyprint source"><code>&lt;div class='button-ba'>
  &lt;button onclick='doButton(this)' style='background-color:yellow'>Do it&lt;/button>
  &lt;!-- other buttons -->
&lt;/div>
</code></pre>
<ul>
<li>Examples of usage are given <a href="">here</a> and <a href="">there</a>.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Members</h3>

        
            
<h4 class="name" id=".verbose"><span class="type-signature type-signature-static">(static) </span>verbose<span class="type-signature"></span></h4>





<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Defines if the curl call is verbose.</p>
<ul>
<li>If true output a message in the <code>&lt;div id='console' ...</code> before and after the call.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>





<div class="description usertext">
    <p>Defines if the curl call is verbose.</p>
<ul>
<li>If true output a message in the <code>&lt;div id='console' ...</code> before and after the call.</li>
</ul>
</div>








        
    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id=".addButtonOnOff"><span class="type-signature type-signature-static">(static) </span>addButtonOnOff<span class="signature">(id, options, callback)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Creates a button which is alternatively on and off.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>id</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>A unique ID to index the HTML element</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>options</code></td>
            

            <td class="type">
            
                
<span class="param-type">object</span>



            
            </td>

            

            

            <td class="description last"><p>Optional options,
defining the element on and off text and <a href="https://www.w3schools.com/cssref/css_colors.asp">color</a>, and optional CSS style directives:</p>
<pre class="prettyprint source"><code>{
  on_text: &quot;ON&quot;,
  off_text: &quot;OFF&quot;,
  on_color: &quot;red&quot;,
  off_color: &quot;lightgreen&quot;,
  style: &quot;&quot;
}
</code></pre></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>callback</code></td>
            

            <td class="type">
            
                
<span class="param-type">callback</span>



            
            </td>

            

            

            <td class="description last"><p>A <code>callback(on_else_off)</code> function called when the button is clicked.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id=".addButtonRange"><span class="type-signature type-signature-static">(static) </span>addButtonRange<span class="signature">(id, options, callback)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Creates a button to input a numerical value.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>id</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>A unique ID to index the HTML element</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>options</code></td>
            

            <td class="type">
            
                
<span class="param-type">object</span>



            
            </td>

            

            

            <td class="description last"><p>Optional options,
defining the element value minimal, maximal and initial default value, the text input number of chars, the slider width in pixel, and optional CSS style directives:</p>
<pre class="prettyprint source"><code>{
  min: 0,
  max: 100,
  default: 50, 
  size: 4,
  width: 200,
  style: &quot;&quot;
}
</code></pre></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>callback</code></td>
            

            <td class="type">
            
                
<span class="param-type">callback</span>



            
            </td>

            

            

            <td class="description last"><p>A <code>callback(value)</code> function called when the value is changed.</p>
<ul>
<li>A global variable is also assigned with value, its name corresponds to the ID in lowercase with '_' for any non-letter, e.g., &quot;My value&quot; writes &quot;my_value&quot;.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id=".addConsole"><span class="type-signature type-signature-static">(static) </span>addConsole<span class="signature">(verbose)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Adds a textual console to print some log information.</p>
<ul>
<li>It is inserted in the HTML using a construct of the form:</li>
</ul>
<pre class="prettyprint source"><code>&lt;script>webcontrols.addConsole();&lt;/script>
</code></pre>
<ul>
<li>The <code>webcontrols.consoleLog(string)</code> and <code>webcontrols.consoleClear()</code> functions allows to use the console.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>verbose</code></td>
            

            <td class="type">
            
                
<span class="param-type">boolean</span>



            
            </td>

            

            

            <td class="description last"><p>If true the curl function outputs a message before and after the call.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id=".consoleLog"><span class="type-signature type-signature-static">(static) </span>consoleLog<span class="signature">(text)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Prints a message in the console.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>text</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>The message string, without HTML tag, a newline is added.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id=".loadJSON"><span class="type-signature type-signature-static">(static) </span>loadJSON<span class="signature">(url, callback<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Gets a remote JSON file.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>url</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The JSON file URL.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>callback</code></td>
            

            <td class="type">
            
                
<span class="param-type">callback</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>function(value){}</code>
                
                </td>
            

            <td class="description last"><p>The callback that handles the JSON returned value, as a text.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id=".consoleClear"><span class="type-signature type-signature-static">(static) </span>consoleClear<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Clears the text in the console.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id=".curl"><span class="type-signature type-signature-static">(static) </span>curl<span class="signature">(url<span class="signature-attributes">opt</span>, input<span class="signature-attributes">opt</span>, method<span class="signature-attributes">opt</span>, callback<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {string}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Performs a Javascript HTTP request to dialog with a web service and returns response.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>url</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>""</code>
                
                </td>
            

            <td class="description last"><p>The HTTP URL.</p>
<ul>
<li>An URL of the form <code>@/$route</code> stands for <code>http[s]:/$hostname:$port/$route</code> considering the current page address.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>input</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>""</code>
                
                </td>
            

            <td class="description last"><p>The URL query or content:</p>
<ul>
<li>GET method, the URL query, if not empty, it is appended to the URL adding and prefixed with a '?' char, thus input is empty.</li>
<li>POST method, the URL query, a string of the form <em>name_1=encodeURIComponent(value_1)&amp;name_2=encodeURIComponent(value_2)</em>, which will be URL encoded.</li>
<li>PUT method, the URL put content, a string of the form <em>name_1=encodeURIComponent(value_1)&amp;name_2=encodeURIComponent(value_2)</em>, usually encoded as a JSON string.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>method</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>"GET"</code>
                
                </td>
            

            <td class="description last"><p>Either <code>GET</code>, <code>POST</code> or <code>PUT</code>, i.e. the HTTP method.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>callback</code></td>
            

            <td class="type">
            
                
<span class="param-type">callback</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>function(value){}</code>
                
                </td>
            

            <td class="description last"><p>The callback that handles the query return value.</p>
<ul>
<li>Runs the <tt>callback(value: string, error: string)</tt> function with
<ul>
<li>value: the query answer value,</li>
<li>error: false if no error, else the http.status as a string.</li>
</ul>
</li>
<li>If the server is not running, or if the query is invalid or not implemented, the callback value is the empty string, and information is given in the console of the browser.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The response value, or an error message, if any.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">string</span>



    </dd>
</dl>

    



        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>